<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Arduino BLE Support</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Arduino BLE Support </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>As part of this Github project, we provide libraries for Bluetooth Low Energy (BLE) for the ESP32 Arduino environment. Support for this capability is still in the process of being cooked (as of November 2017). As such you should not build product based on these functions as changes to the API and implementation are extremely likely over the next couple of months.</p>
<p>That said, we now have the ability to produce a driver you can use for testing. This will give you early access to the function while give those who choose to build and maintain the code early feedback on what works, what doesn't and what can be improved from a usage perspective.</p>
<p>When complete, the BLE support for ESP32 Arduino will be available as a single ZIP file. The file will be called <b>ESP32_BLE.zip</b>. It is this file that will be able to be imported into the Arduino IDE from the <code>Sketch -&gt; Include Library -&gt; Add .ZIP library</code>. When initial development of the library has been completed, this ZIP will be placed under some form of release control so that an ordinary Arduino IDE user can simply download this as a unit and install.</p>
<p>Update: As of 2017-11, the BLE support has been included with the Arduino ESP32 base package.</p>
<p>A build of the BLE support for Arduino can be found through the Arduino IDE. Visit <code>Sketch -&gt; Include Library -&gt; Manage Libraries</code>. In the library filter, enter "esp32 ble arduino". The search will narrow and you should see "ESP32 BLE Arduino" available for installation or upgrade.</p>
<p>Should you wish to build your own instance of the ZIP from the source, here is the recipe.</p>
<ol type="1">
<li>Create a new directory called <code>build</code></li>
<li>Enter that directory and run <code>git clone <a href="https://github.com/nkolban/esp32-snippets.git">https://github.com/nkolban/esp32-snippets.git</a></code></li>
<li>Change into the directory called <code>./esp32_snippets/cpp_utils</code></li>
<li>Run <code>make -f Makefile.arduino build_ble</code></li>
<li>Change into the directory called <code>./Arduino</code></li>
</ol>
<p>And here you will find the <code>ESP32_BLE.zip</code> that is build from the latest source. You can then install this into your Arduino IDE environment are you are ready to go.</p>
<h2>Installing a new version</h2>
<p>If you have previously installed a version of the Arduino BLE Support and need to install a new one, follow the steps above to build yourself a new instance of the <code>ESP32_BLE.zip</code> that is ready for installation. I recommend removing the old one before installing the new one. To remove the old one, find the directory where the Arduino IDE stores your libraries (on Linux this is commonly <code>$HOME/Arduino</code>). In there you will find a directory called <code>libraries</code> and, if you have previously installed the BLE support, you will find a directory called <code>ESP32_BLE</code>. Remove that directory.</p>
<h2>Replacing the version that comes with Arduino-ESP32</h2>
<p>From October 2017 onwards, a build of the BLE libraries is supplied with the Arduino-ESP32 distribition which means that you should just be able to use the function without performing any additional steps. The intent is to keep the BLE libraries in this project completely in synch with the Arduino-ESP32 distribution. However, there may be times when a bug fix is needed which you may wish to try before an official distribution in Arduino-ESP32. That should be extremely rare. However, just in case it is needed, here is the recipe:</p>
<ol type="1">
<li>Go to <code>&lt;ArduinoIDE&gt;/hardware/espressif/esp32/libraries</code></li>
<li>Delete the directory called <code>BLE</code></li>
<li>Go to your <code>&lt;Arduino&gt;/libraries</code> folder</li>
<li>Extract the <code>ESP32_BLE.zip</code> file there</li>
</ol>
<h2>Switching on debugging</h2>
<p>The BLE support contains extensive internal diagnostics which can be switched on through the <code>Tools &gt; Core Debug Level</code> setting:</p>
<img src="https://github.com/nkolban/esp32-snippets/blob/master/Documentation/images/arduino_debug.png" alt="" class="inline"/>
<h2>Decoding an exception stack trace</h2>
<p>While using the BLE C++ classes there is always the unfortunate possibility that something will go wrong and your application crash. Fortunately, this results in some debug information being logged to the console. This is known as a <em>stack trace</em>. Included in the stack trace are a sequence of hexadecimal numbers known as the <em>back trace</em> which are the list of addresses of functions that were executed just before the crash was detected. If we could decode these we would have a lot of great information that could be used to aid in the resolution. Fortunately there is a fantastic project that makes decoding this information very easy indeed.</p>
<p>This project can be found here:</p>
<p><a href="https://github.com/me-no-dev/EspExceptionDecoder">https://github.com/me-no-dev/EspExceptionDecoder</a></p>
<p>If you start to encounter crashes in your BLE C++ applications and wish to report these through Github issues, please help us to help you by installing this tool int your Arduino IDE and including the decoded information in the issue report. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
